## virtualbox-hwe 5.1.38

=== src/apps/svnsync-vbox/Makefile ===
#
# Makefile
#
#
# Copyright (C) 2006-2015 Oracle Corporation
#
# This file is part of VirtualBox Open Source Edition (OSE), as
# available from http://www.virtualbox.org. This file is free software;
# you can redistribute it and/or modify it under the terms of the GNU
# General Public License (GPL) as published by the Free Software
# Foundation, in version 2 as it comes in the "COPYING" file of the
# VirtualBox OSE distribution. VirtualBox OSE is distributed in the
# hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
#

CC = gcc
CFLAGS = -O2 -g -Wall -pedantic -Wno-long-long -Wno-trigraphs \
  -Wmissing-prototypes -Wstrict-prototypes -Wmissing-declarations
DEFS = -DVBOX -D_FILE_OFFSET_BITS=64
INCS = -I. -I/usr/include/subversion-1 -I/usr/include/apr-1.0
LIBS = -lsvn_ra-1 -lsvn_ra_local-1 \
  -lsvn_repos-1 -lsvn_fs-1 -lsvn_delta-1 \
  -lsvn_subr-1 -lapr-1 -laprutil-1 \
  -ldb

all: svnsync-vbox

svnsync-vbox: main.c
	$(CC) $(CFLAGS) $(DEFS) $(INCS) $(LIBS) -o $@ $<

svnsync-vbox: svn_private_config.h

svnsync-vbox: Makefile

=== src/VBox/HostDrivers/VBoxNetAdp/freebsd/Makefile ===
# $Id: Makefile $
## @file
# Makefile for the VirtualBox FreeBSD Host Driver.
#

#
#
# Copyright (C) 2006-2015 Oracle Corporation
#
# This file is part of VirtualBox Open Source Edition (OSE), as
# available from http://www.virtualbox.org. This file is free software;
# you can redistribute it and/or modify it under the terms of the GNU
# General Public License (GPL) as published by the Free Software
# Foundation, in version 2 as it comes in the "COPYING" file of the
# VirtualBox OSE distribution. VirtualBox OSE is distributed in the
# hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
#

KMOD = vboxnetadp

CFLAGS += -DRT_OS_FREEBSD -DIN_RING0 -DIN_RT_R0 -DIN_SUP_R0 -DVBOX -DRT_WITH_VBOX -Iinclude -I. -Ir0drv -w -DVBOX_WITH_HARDENING -DVIMAGE

.if (${MACHINE_ARCH} == "i386")
 CFLAGS += -DRT_ARCH_X86
.elif (${MACHINE_ARCH} == "amd64")
 CFLAGS += -DRT_ARCH_AMD64
.endif

SRCS = \
	VBoxNetAdp-freebsd.c \
	VBoxNetAdp.c

SRCS += device_if.h bus_if.h

.include <bsd.kmod.mk>

=== src/VBox/HostDrivers/VBoxNetFlt/linux/Makefile ===
#
# Makefile for the VirtualBox Linux Host Network Filter Driver.
# (For 2.6.x this file must be called 'Makefile'!)
#

#
#
# Copyright (C) 2006-2015 Oracle Corporation
#
# This file is part of VirtualBox Open Source Edition (OSE), as
# available from http://www.virtualbox.org. This file is free software;
# you can redistribute it and/or modify it under the terms of the GNU
# General Public License (GPL) as published by the Free Software
# Foundation, in version 2 as it comes in the "COPYING" file of the
# VirtualBox OSE distribution. VirtualBox OSE is distributed in the
# hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
#

#
# First, figure out which architecture we're targeting and the build type.
# (We have to support basic cross building (ARCH=i386|x86_64).)
# While at it, warn about BUILD_* vars found to help with user problems.
#
ifeq ($(filter-out x86_64 amd64 AMD64,$(shell uname -m)),)
 BUILD_TARGET_ARCH_DEF := amd64
else
 BUILD_TARGET_ARCH_DEF := x86
endif
ifneq ($(filter-out amd64 x86,$(BUILD_TARGET_ARCH)),)
 $(warning Ignoring unknown BUILD_TARGET_ARCH value '$(BUILD_TARGET_ARCH)'.)
 BUILD_TARGET_ARCH :=
endif
ifeq ($(BUILD_TARGET_ARCH),)
 ifeq ($(ARCH),x86_64)
  BUILD_TARGET_ARCH := amd64
 else
  ifeq ($(ARCH),i386)
   BUILD_TARGET_ARCH := x86
  else
   BUILD_TARGET_ARCH := $(BUILD_TARGET_ARCH_DEF)
  endif
 endif
else
 ifneq ($(BUILD_TARGET_ARCH),$(BUILD_TARGET_ARCH_DEF))
  $(warning Using BUILD_TARGET_ARCH='$(BUILD_TARGET_ARCH)' from the $(origin BUILD_TARGET_ARCH).)
 endif
endif

ifneq ($(filter-out release profile debug strict,$(BUILD_TYPE)),)
 $(warning Ignoring unknown BUILD_TYPE value '$(BUILD_TYPE)'.)
 BUILD_TYPE :=
endif
ifeq ($(BUILD_TYPE),)
 BUILD_TYPE := release
else
 ifneq ($(BUILD_TYPE),release)
  $(warning Using BUILD_TYPE='$(BUILD_TYPE)' from the $(origin BUILD_TYPE).)
 endif
endif

# override is required by the Debian guys
override MODULE = vboxnetflt
OBJS   = \
	linux/VBoxNetFlt-linux.o \
	VBoxNetFlt.o \
	SUPR0IdcClient.o \
	SUPR0IdcClientComponent.o \
	linux/SUPR0IdcClient-linux.o

ifeq ($(BUILD_TARGET_ARCH),x86)
OBJS += math/gcc/divdi3.o \
	math/gcc/moddi3.o \
	math/gcc/qdivrem.o \
	math/gcc/udivdi3.o \
	math/gcc/udivmoddi4.o \
        math/gcc/divdi3.o \
	math/gcc/umoddi3.o
endif

ifneq ($(MAKECMDGOALS),clean)

ifeq ($(KERNELRELEASE),)

 #
 # building from this directory
 #

 # kernel base directory
 ifndef KERN_DIR
  # build for the current kernel, version check
  KERN_DIR := /lib/modules/$(shell uname -r)/build
  ifneq ($(shell if test -d $(KERN_DIR); then echo yes; fi),yes)
   KERN_DIR := /usr/src/linux
   ifneq ($(shell if test -d $(KERN_DIR); then echo yes; fi),yes)
    $(error Error: unable to find the sources of your current Linux kernel. \
	           Specify KERN_DIR=<directory> and run Make again)
   endif
   $(warning Warning: using /usr/src/linux as the source directory of your \
                      Linux kernel. If this is not correct, specify \
		      KERN_DIR=<directory> and run Make again.)
  endif
 else
  ifneq ($(shell if test -d $(KERN_DIR); then echo yes; fi),yes)
   $(error Error: KERN_DIR does not point to a directory)
  endif
 endif

 # includes
 ifndef KERN_INCL
  KERN_INCL = $(KERN_DIR)/include
 endif
 ifneq ($(shell if test -d $(KERN_INCL); then echo yes; fi),yes)
  $(error Error: unable to find the include directory for your current Linux \
                 kernel. Specify KERN_INCL=<directory> and run Make again)
 endif

 # module install dir, only for current kernel
 ifneq ($(filter install install_rpm,$(MAKECMDGOALS)),)
  ifndef MODULE_DIR
   MODULE_DIR_TST := /lib/modules/$(shell uname -r)
   ifeq ($(shell if test -d $(MODULE_DIR_TST); then echo yes; fi),yes)
    MODULE_DIR := $(MODULE_DIR_TST)/misc
   else
    $(error Unable to find the folder to install the support driver to)
   endif
  endif # MODULE_DIR unspecified
 endif

else # neq($(KERNELRELEASE),)

 #
 # building from kbuild (make -C <kernel_directory> M=`pwd`)
 #

endif # neq($(KERNELRELEASE),)

# debug - show guesses.
ifdef DEBUG
$(warning dbg: KERN_DIR     = $(KERN_DIR))
$(warning dbg: KERN_INCL    = $(KERN_INCL))
$(warning dbg: MODULE_DIR   = $(MODULE_DIR))
endif

KBUILD_VERBOSE ?= 1

#
# Compiler options
#
ifndef INCL
 INCL    := $(addprefix -I,$(KERN_INCL) $(EXTRA_INCL))
 ifndef KBUILD_EXTMOD
  KBUILD_EXTMOD := $(shell pwd)
 endif
 INCL    += $(addprefix -I$(KBUILD_EXTMOD),/ /include /r0drv/linux)
 INCL    += $(addprefix -I$(KBUILD_EXTMOD)/vboxnetflt,/ /include /r0drv/linux)
 export INCL
endif
ifneq ($(wildcard $(KBUILD_EXTMOD)/vboxnetflt),)
 MANGLING := $(KBUILD_EXTMOD)/vboxnetflt/include/VBox/SUPDrvMangling.h
else
 MANGLING := $(KBUILD_EXTMOD)/include/VBox/SUPDrvMangling.h
endif
KFLAGS   := -D__KERNEL__ -DMODULE -DRT_OS_LINUX -DIN_RING0 -DIN_RT_R0 \
	    -DIN_SUP_R0 -DVBOX -DRT_WITH_VBOX -DVBOX_WITH_HARDENING \
	    -Wno-declaration-after-statement
ifdef VBOX_REDHAT_KABI
 KFLAGS  += -DVBOX_REDHAT_KABI
endif
ifeq ($(BUILD_TARGET_ARCH),amd64)
 KFLAGS  += -DRT_ARCH_AMD64
else
 KFLAGS  += -DRT_ARCH_X86
endif
# must be consistent with Config.kmk!
KFLAGS  += -DVBOX_WITH_64_BITS_GUESTS
ifeq ($(BUILD_TYPE),debug)
 KFLAGS  += -DDEBUG -DDEBUG_$(USER) -g
 # IPRT_DEBUG_SEMS indicates thread wrt sems state via the comm field.
 #KFLAGS  += -DIPRT_DEBUG_SEMS
endif

# By default we use remap_pfn_range() kernel API to make kernel pages
# visible for userland. Unfortunately, it leads to situation that
# during debug session all structures on that page (such as PVM pointer)
# are not accessible to the debugger (see #3214).
# This code enables experimental support
# for vm_insert_page() kernel API, allowing to export kernel pages
# to the userland in more debugger-friendly way. Due to stability
# concerns, not enabled by default yet.
ifdef VBOX_USE_INSERT_PAGE
 KFLAGS  += -DVBOX_USE_INSERT_PAGE
endif

MODULE_EXT    := ko
$(MODULE)-y   := $(OBJS)

# build defs
EXTRA_CFLAGS  += -include $(MANGLING) $(INCL) $(KFLAGS) $(KDEBUG) -fno-pie

all: $(MODULE)

obj-m += $(MODULE).o

JOBS := $(shell (getconf _NPROCESSORS_ONLN || grep -Ec '^processor|^CPU[0-9]' /proc/cpuinfo) 2>/dev/null)
ifeq ($(JOBS),0)
  JOBS := 1
endif

# OL/UEK: disable module signing for external modules -- we don't have any private key
$(MODULE):
	$(MAKE) KBUILD_VERBOSE=$(KBUILD_VERBOSE) SUBDIRS=$(CURDIR) SRCROOT=$(CURDIR) CONFIG_MODULE_SIG= -C $(KERN_DIR) -j$(JOBS) modules

install: $(MODULE)
	@mkdir -p $(MODULE_DIR); \
	install -m 0644 -o root -g root $(MODULE).$(MODULE_EXT) $(MODULE_DIR); \
	PATH="$(PATH):/bin:/sbin" depmod -a; \
	rm -f /etc/vbox/module_not_compiled

install_rpm: $(MODULE)
	@mkdir -p $(MODULE_DIR); \
	install -m 0644 $(MODULE).$(MODULE_EXT) $(MODULE_DIR)

else # eq ($(MAKECMDGOALS),clean)

 ifndef KERN_DIR
  KERN_DIR := /lib/modules/$(shell uname -r)/build
  ifeq ($(wildcard $(KERN_DIR)/Makefile),)
   KERN_DIR := /usr/src/linux
  endif
 endif
 ifeq ($(wildcard $(KERN_DIR)/Makefile),)

clean:
	find . \( -name \*.o -o -name \*.cmd \) -print0 | xargs -0 rm -f
	rm -rf .tmp_ver* $(MODULE).* Module.symvers Modules.symvers modules.order

 else

clean:
	$(MAKE) KBUILD_VERBOSE=$(KBUILD_VERBOSE) SUBDIRS=$(CURDIR) SRCROOT=$(CURDIR) -C $(KERN_DIR) clean

 endif

endif # eq($(MAKECMDGOALS),clean)

=== src/VBox/HostDrivers/VBoxPci/linux/Makefile ===
#
# Makefile for the VirtualBox Linux Host PCI Driver.
# (For 2.6.x this file must be called 'Makefile'!)
#

#
#
# Copyright (C) 2011-2015 Oracle Corporation
#
# This file is part of VirtualBox Open Source Edition (OSE), as
# available from http://www.virtualbox.org. This file is free software;
# you can redistribute it and/or modify it under the terms of the GNU
# General Public License (GPL) as published by the Free Software
# Foundation, in version 2 as it comes in the "COPYING" file of the
# VirtualBox OSE distribution. VirtualBox OSE is distributed in the
# hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
#

#
# First, figure out which architecture we're targeting and the build type.
# (We have to support basic cross building (ARCH=i386|x86_64).)
# While at it, warn about BUILD_* vars found to help with user problems.
#
ifeq ($(filter-out x86_64 amd64 AMD64,$(shell uname -m)),)
 BUILD_TARGET_ARCH_DEF := amd64
else
 BUILD_TARGET_ARCH_DEF := x86
endif
ifneq ($(filter-out amd64 x86,$(BUILD_TARGET_ARCH)),)
 $(warning Ignoring unknown BUILD_TARGET_ARCH value '$(BUILD_TARGET_ARCH)'.)
 BUILD_TARGET_ARCH :=
endif
ifeq ($(BUILD_TARGET_ARCH),)
 ifeq ($(ARCH),x86_64)
  BUILD_TARGET_ARCH := amd64
 else
  ifeq ($(ARCH),i386)
   BUILD_TARGET_ARCH := x86
  else
   BUILD_TARGET_ARCH := $(BUILD_TARGET_ARCH_DEF)
  endif
 endif
else
 ifneq ($(BUILD_TARGET_ARCH),$(BUILD_TARGET_ARCH_DEF))
  $(warning Using BUILD_TARGET_ARCH='$(BUILD_TARGET_ARCH)' from the $(origin BUILD_TARGET_ARCH).)
 endif
endif

ifneq ($(filter-out release profile debug strict,$(BUILD_TYPE)),)
 $(warning Ignoring unknown BUILD_TYPE value '$(BUILD_TYPE)'.)
 BUILD_TYPE :=
endif
ifeq ($(BUILD_TYPE),)
 BUILD_TYPE := release
else
 ifneq ($(BUILD_TYPE),release)
  $(warning Using BUILD_TYPE='$(BUILD_TYPE)' from the $(origin BUILD_TYPE).)
 endif
endif

# override is required by the Debian guys
override MODULE = vboxpci
OBJS   =                          	\
	linux/VBoxPci-linux.o     	\
	VBoxPci.o                 	\
        SUPR0IdcClient.o          	\
        SUPR0IdcClientComponent.o    	\
        linux/SUPR0IdcClient-linux.o

ifeq ($(BUILD_TARGET_ARCH),x86)
OBJS += math/gcc/divdi3.o       \
	math/gcc/moddi3.o 	\
	math/gcc/qdivrem.o 	\
	math/gcc/udivdi3.o 	\
	math/gcc/udivmoddi4.o 	\
        math/gcc/divdi3.o 	\
	math/gcc/umoddi3.o
endif

ifneq ($(MAKECMDGOALS),clean)

ifeq ($(KERNELRELEASE),)

 #
 # building from this directory
 #

 # kernel base directory
 ifndef KERN_DIR
 # build for the current kernel, version check
  KERN_DIR := /lib/modules/$(shell uname -r)/build
  ifneq ($(shell if test -d $(KERN_DIR); then echo yes; fi),yes)
   KERN_DIR := /usr/src/linux
   ifneq ($(shell if test -d $(KERN_DIR); then echo yes; fi),yes)
    $(error Error: unable to find the sources of your current Linux kernel. \
	           Specify KERN_DIR=<directory> and run Make again)
   endif
   $(warning Warning: using /usr/src/linux as the source directory of your \
                      Linux kernel. If this is not correct, specify \
		      KERN_DIR=<directory> and run Make again.)
  endif
 else
  ifneq ($(shell if test -d $(KERN_DIR); then echo yes; fi),yes)
   $(error Error: KERN_DIR does not point to a directory)
  endif
 endif

 # includes
 ifndef KERN_INCL
  KERN_INCL = $(KERN_DIR)/include
 endif
 ifneq ($(shell if test -d $(KERN_INCL); then echo yes; fi),yes)
  $(error Error: unable to find the include directory for your current Linux \
                 kernel. Specify KERN_INCL=<directory> and run Make again)
 endif

 # module install dir, only for current kernel
 ifneq ($(filter install install_rpm,$(MAKECMDGOALS)),)
  ifndef MODULE_DIR
   MODULE_DIR_TST := /lib/modules/$(shell uname -r)
   ifeq ($(shell if test -d $(MODULE_DIR_TST); then echo yes; fi),yes)
    MODULE_DIR := $(MODULE_DIR_TST)/misc
   else
    $(error Unable to find the folder to install the support driver to)
   endif
  endif # MODULE_DIR unspecified
 endif

else # neq($(KERNELRELEASE),)

 #
 # building from kbuild (make -C <kernel_directory> M=`pwd`)
 #

endif # neq($(KERNELRELEASE),)

# debug - show guesses.
ifdef DEBUG
$(warning dbg: KERN_DIR     = $(KERN_DIR))
$(warning dbg: KERN_INCL    = $(KERN_INCL))
$(warning dbg: MODULE_DIR   = $(MODULE_DIR))
endif

KBUILD_VERBOSE ?= 1

#
# Compiler options
#
ifndef INCL
 INCL    := $(addprefix -I,$(KERN_INCL) $(EXTRA_INCL))
 ifndef KBUILD_EXTMOD
  KBUILD_EXTMOD := $(shell pwd)
 endif
 INCL    += $(addprefix -I$(KBUILD_EXTMOD),/ /include /r0drv/linux)
 INCL    += $(addprefix -I$(KBUILD_EXTMOD)/vboxpci,/ /include /r0drv/linux)
 export INCL
endif
ifneq ($(wildcard $(KBUILD_EXTMOD)/vboxpci),)
 MANGLING := $(KBUILD_EXTMOD)/vboxpci/include/VBox/SUPDrvMangling.h
else
 MANGLING := $(KBUILD_EXTMOD)/include/VBox/SUPDrvMangling.h
endif
KFLAGS   := -D__KERNEL__ -DMODULE -DRT_OS_LINUX -DIN_RING0 -DIN_RT_R0 \
	    -DIN_SUP_R0 -DVBOX -DRT_WITH_VBOX -DVBOX_WITH_HARDENING
ifdef VBOX_REDHAT_KABI
 KFLAGS  += -DVBOX_REDHAT_KABI
endif
ifeq ($(BUILD_TARGET_ARCH),amd64)
 KFLAGS  += -DRT_ARCH_AMD64
else
 KFLAGS  += -DRT_ARCH_X86
endif
# must be consistent with Config.kmk!
KFLAGS  += -DVBOX_WITH_64_BITS_GUESTS
ifeq ($(BUILD_TYPE),debug)
 KFLAGS  += -DDEBUG -DDEBUG_$(USER) -g
 # IPRT_DEBUG_SEMS indicates thread wrt sems state via the comm field.
 #KFLAGS  += -DIPRT_DEBUG_SEMS
endif

# By default we use remap_pfn_range() kernel API to make kernel pages
# visible for userland. Unfortunately, it leads to situation that
# during debug session all structures on that page (such as PVM pointer)
# are not accessible to the debugger (see #3214).
# This code enables experimental support
# for vm_insert_page() kernel API, allowing to export kernel pages
# to the userland in more debugger-friendly way. Due to stability
# concerns, not enabled by default yet.
ifdef VBOX_USE_INSERT_PAGE
 KFLAGS  += -DVBOX_USE_INSERT_PAGE
endif

MODULE_EXT    := ko
$(MODULE)-y   := $(OBJS)

# build defs
EXTRA_CFLAGS  += -include $(MANGLING) $(INCL) $(KFLAGS) $(KDEBUG) -fno-pie

all: $(MODULE)

obj-m += $(MODULE).o

JOBS := $(shell (getconf _NPROCESSORS_ONLN || grep -Ec '^processor|^CPU[0-9]' /proc/cpuinfo) 2>/dev/null)
ifeq ($(JOBS),0)
  JOBS := 1
endif

# OL/UEK: disable module signing for external modules -- we don't have any private key
$(MODULE):
	$(MAKE) KBUILD_VERBOSE=$(KBUILD_VERBOSE) SUBDIRS=$(CURDIR) SRCROOT=$(CURDIR) CONFIG_MODULE_SIG= -C $(KERN_DIR) -j$(JOBS) modules

install: $(MODULE)
	@mkdir -p $(MODULE_DIR); \
	install -m 0644 -o root -g root $(MODULE).$(MODULE_EXT) $(MODULE_DIR); \
	PATH="$(PATH):/bin:/sbin" depmod -a;

install_rpm: $(MODULE)
	@mkdir -p $(MODULE_DIR); \
	install -m 0644 $(MODULE).$(MODULE_EXT) $(MODULE_DIR)

else # eq ($(MAKECMDGOALS),clean)

 ifndef KERN_DIR
  KERN_DIR := /lib/modules/$(shell uname -r)/build
  ifeq ($(wildcard $(KERN_DIR)/Makefile),)
   KERN_DIR := /usr/src/linux
  endif
 endif
 ifeq ($(wildcard $(KERN_DIR)/Makefile),)

clean:
	find . \( -name \*.o -o -name \*.cmd \) -print0 | xargs -0 rm -f
	rm -rf .tmp_ver* $(MODULE).* Module.symvers Modules.symvers modules.order

 else

clean:
	$(MAKE) KBUILD_VERBOSE=$(KBUILD_VERBOSE) SUBDIRS=$(CURDIR) SRCROOT=$(CURDIR) -C $(KERN_DIR) clean

 endif

endif # eq($(MAKECMDGOALS),clean)

=== src/VBox/Devices/EFI/Firmware/VBoxPkg/VBoxMisc/Makefile ===
# $Id: Makefile $
#* @file
# Makefile - assembling the iso image for experimenting with EFI.
#/
#
#
# Copyright (C) 2009-2015 Oracle Corporation
#
# This file is part of VirtualBox Open Source Edition (OSE), as
# available from http://www.virtualbox.org. This file is free software;
# you can redistribute it and/or modify it under the terms of the GNU
# General Public License (GPL) as published by the Free Software
# Foundation, in version 2 as it comes in the "COPYING" file of the
# VirtualBox OSE distribution. VirtualBox OSE is distributed in the
# hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
#
# The contents of this file may alternatively be used under the terms
# of the Common Development and Distribution License Version 1.0
# (CDDL) only, as it comes in the "COPYING.CDDL" file of the
# VirtualBox OSE distribution, in which case the provisions of the
# CDDL are applicable instead of those of the GPL.
#
# You may elect to license modified versions of this file under the
# terms and conditions of either the GPL or the CDDL or both.
#
#/

#
# Here we add modules to be burn on iso-image 
#
SOURCES += VBoxInterceptorDxe.efi
SOURCES += VBoxMimicryDxe.efi

ifeq ($(BUILD_ARCH), IA32)
ARCH_SUFFIX=
else
ARCH_SUFFIX=$(BUILD_ARCH)
endif

BUILD_ARCH ?= IA32
BUILD_DIR=$(WORKSPACE)/Build/VBoxPkg$(ARCH_SUFFIX)/DEBUG_UNIXGCC/$(BUILD_ARCH)

ISO_DIR=efi-app
FILES_TO_ISO=$(foreach file, $(SOURCES), $(addprefix $(ISO_DIR)/, $(file)))

DEST=efi-app.iso
all:${DEST}

$(DEST):$(FILES_TO_ISO)
	mkisofs -R -o $@ $(basename $@)

$(ISO_DIR)/%.efi:$(BUILD_DIR)/%.efi
	cp $< $@

clean:
	$(RM) -rf ${DEST} $(FILES_TO_ISO)

=== src/VBox/Main/webservice/samples/java/jax-ws/Makefile ===
#
# Copyright (C) 2008-2010 Oracle Corporation
#
# This file is part of VirtualBox Open Source Edition (OSE), as
# available from http://www.virtualbox.org. This file is free software;
# you can redistribute it and/or modify it under the terms of the GNU
# General Public License (GPL) as published by the Free Software
# Foundation, in version 2 as it comes in the "COPYING" file of the
# VirtualBox OSE distribution. VirtualBox OSE is distributed in the
# hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
#

JAVA16=java
JAVA15=/usr/lib/jvm/java-1.5.0-sun/bin/java
JAVAC = javac
JAVAC15 = javac -target 1.5
JAVAC16 = javac -target 1.6
MKDIR = mkdir
RM = rm

DEST16 = ./gen16
DEST15 = ./gen15

VBOXWS15 = ../lib/vboxws_java15.jar
VBOXWS16 = ../lib/vboxws_java16.jar

JAXWS=./jaxws-ri
JAXWSLIBS=$(JAXWS)/lib/jaxws-api.jar:$(JAXWS)/lib/jaxb-api.jar:$(JAXWS)/lib/jsr181-api.jar:$(JAXWS)/lib/jaxws-rt.jar

all: run16

metric: metric16

$(DEST16)/clienttest.class: clienttest.java
	$(MKDIR) -p $(DEST16)
	$(JAVAC16) -d $(DEST16) -cp $(VBOXWS16) $<

$(DEST15)/clienttest.class: clienttest.java
	$(MKDIR) -p $(DEST15)
	$(JAVAC15) -d $(DEST15) -cp $(VBOXWS15):$(JAXWSLIBS) $<

run16: $(DEST16)/clienttest.class
	$(JAVA16) -cp $(VBOXWS16):$(DEST16) clienttest show vms

run15: $(DEST15)/clienttest.class
	$(JAVA15) -cp $(VBOXWS15):$(JAXWSLIBS):$(DEST15) clienttest show vms

$(DEST16)/metrictest.class: metrictest.java
	$(MKDIR) -p $(DEST16)
	$(JAVAC16) -d $(DEST16) -cp $(VBOXWS16) $<

$(DEST15)/metrictest.class: metrictest.java
	$(MKDIR) -p $(DEST15)
	$(JAVAC15) -d $(DEST15) -cp $(VBOXWS15):$(JAXWSLIBS) $<

metric16: $(DEST16)/metrictest.class
	-$(JAVA16) -cp $(VBOXWS16):$(DEST16) metrictest

metric15: $(DEST15)/metrictest.class
	-$(JAVA15) -cp $(VBOXWS15):$(JAXWSLIBS):$(DEST15) metrictest

clean:
	$(RM) -rf $(DEST15)  $(DEST16)

=== src/VBox/Devices/EFI/Firmware/BaseTools/Source/C/PyUtility/Makefile ===
## @file
# Makefile
#
# Copyright (c) 2007 - 2014, Intel Corporation. All rights reserved.<BR>
# This program and the accompanying materials
# are licensed and made available under the terms and conditions of the BSD License
# which accompanies this distribution.    The full text of the license may be found at
# http://opensource.org/licenses/bsd-license.php
#
# THE PROGRAM IS DISTRIBUTED UNDER THE BSD LICENSE ON AN "AS IS" BASIS,
# WITHOUT WARRANTIES OR REPRESENTATIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED.
#

!INCLUDE ..\Makefiles\ms.common

APPNAME = GenSec

LIBS = $(LIB_PATH)\Common.lib

OBJECTS = PyUtility.obj

#CFLAGS = $(CFLAGS) /nodefaultlib:libc.lib

!INCLUDE ..\Makefiles\ms.app

=== src/VBox/ExtPacks/VBoxDTrace/onnv/cmd/dtrace/test/cmd/chkargs/Makefile ===
#
# CDDL HEADER START
#
# The contents of this file are subject to the terms of the
# Common Development and Distribution License (the "License").
# You may not use this file except in compliance with the License.
#
# You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
# or http://www.opensolaris.org/os/licensing.
# See the License for the specific language governing permissions
# and limitations under the License.
#
# When distributing Covered Code, include this CDDL HEADER in each
# file and include the License file at usr/src/OPENSOLARIS.LICENSE.
# If applicable, add the following below this CDDL HEADER, with the
# fields enclosed by brackets "[]" replaced with your own identifying
# information: Portions Copyright [yyyy] [name of copyright owner]
#
# CDDL HEADER END
#

#
# Copyright 2008 Sun Microsystems, Inc.  All rights reserved.
# Use is subject to license terms.
#
#ident	"%Z%%M%	%I%	%E% SMI"

include $(SRC)/cmd/Makefile.cmd

SUBDIRS = $(MACH)
$(BUILD64)SUBDIRS += $(MACH64)

include ../../Makefile.subdirs

## virtualbox-hwe 5.1.38-dfsg

=== debian/changelog ===
virtualbox-hwe (5.1.38-dfsg-0ubuntu1.16.04.2) xenial; urgency=medium

  * debian/patches/fix-compile-for-xenial-kernel.patch
    - Fix for LP: #1818049 (virtualbox dkms modules fail to build with
      linux 4.4.0-143.169)

 -- Kleber Sacilotto de Souza <kleber.souza@canonical.com>  Thu, 28 Feb 2019 16:06:20 +0100

virtualbox-hwe (5.1.38-dfsg-0ubuntu1.16.04.1) xenial; urgency=medium

  * Build only the guest-* packages with hwe stack

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 09 Jul 2018 17:10:10 +0200

virtualbox (5.1.38-dfsg-0ubuntu1.16.04.1) xenial; urgency=medium

  * New upstream version 5.1.38-dfsg
    - fixes for kernel 3.16 and 3.17
    - fixes for opengl libraries
    - automatically detect if 3d is enabled or not
    LP: #1762491

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 10 Jul 2018 12:40:22 +0200

virtualbox-hwe (5.1.34-dfsg-0ubuntu1.16.04.2) xenial; urgency=medium

  * Build only the guest-* packages with hwe stack

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 02 Feb 2018 13:27:46 +0100

virtualbox (5.1.34-dfsg-0ubuntu1.16.04.2) xenial; urgency=medium

  * New upstream version 5.1.34-dfsg
    LP: #1746316 -> security patches for spectre and meltdown
    LP: #1736116 -> freeze with kernel >= 4.13
  * Apply 69989 to fix GL issue.
  * Lower compat level to 9

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 02 Feb 2018 13:27:46 +0100

virtualbox (5.1.30-dfsg-1) unstable; urgency=medium

  * New upstream version 5.1.30-dfsg

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 17 Oct 2017 08:50:29 +0200

virtualbox (5.1.28-dfsg-3) unstable; urgency=medium

  * Drop the ntp conflict, users seems to be not happy with not having it.
    Closes: #878074.
    People are already advised to *not* use it, and use the guest tools
    instead.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 10 Oct 2017 19:34:19 +0200

virtualbox (5.1.28-dfsg-2) unstable; urgency=high

  * Conflict with ntp services due to systemd hack removed.
    (Closes: #873263)
    (thanks to the various systemd maintainers and upstream for the help)
  * Bump std-version to 4.1.1

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 04 Oct 2017 16:47:29 +0200

virtualbox (5.1.28-dfsg-1) unstable; urgency=medium

  * Remove double "in" keyword, to make lintian happy
  * New upstream version 5.1.28-dfsg
  * Bump std-version to 4.1.0
  * drop old patch cherry-pick-68274: upstream

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 14 Sep 2017 19:42:08 +0200

virtualbox (5.1.26-dfsg-2) unstable; urgency=medium

  * Cherry-pick gcc warning fix 68274

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 07 Aug 2017 12:09:45 +0200

virtualbox (5.1.26-dfsg-1) unstable; urgency=medium

  * New upstream version 5.1.26-dfsg
  * Drop vboxxpcom patch merged upstream

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 28 Jul 2017 09:58:32 +0200

virtualbox (5.1.24-dfsg-2) unstable; urgency=medium

  [ Andreas Heinlein ]
  * debian/patches/vboxxpcom.py.patch:
    - Fix python3 binding (Upstream ticket:
      https://www.virtualbox.org/ticket/16899
      Closes: #868853
      Thanks Andreas Heinlein for the report and fix!

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 19 Jul 2017 11:31:27 +0200

virtualbox (5.1.24-dfsg-1) unstable; urgency=medium

  * New upstream version 5.1.24, patch refresh
  * Add iproute2 (Closes: #867129)
    - Thanks Zhang Jingqiang <zh_jq@outlook.com> for reporting!

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 18 Jul 2017 15:28:52 +0200

virtualbox (5.1.22-dfsg-4) unstable; urgency=medium

  * No change rebuild with new debhelper (Closes: #868290)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 13 Jul 2017 23:56:46 +0200

virtualbox (5.1.22-dfsg-3) unstable; urgency=medium

  * Switch compat level to 10
  * Bump std-version to 4.0.0

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 11 Jul 2017 23:57:11 +0200

virtualbox (5.1.22-dfsg-2) unstable; urgency=medium

  [ Michael Hudson-Doyle ]
  * Look for Python 3.6 as well as all older versions.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 24 Jun 2017 15:00:47 +0200

virtualbox (5.1.22-dfsg-1) unstable; urgency=medium

  * New upstream release.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 29 Apr 2017 11:10:07 +0200

virtualbox (5.1.20-dfsg-2) unstable; urgency=medium

  * Add two missing files, from new 5.1.20a upstream tarball.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 19 Apr 2017 11:11:21 +0200

virtualbox (5.1.20-dfsg-1) unstable; urgency=medium

  * New upstream release, patch refresh.
    - drop prime patch

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 19 Apr 2017 08:05:49 +0200

virtualbox (5.1.18-dfsg-1) unstable; urgency=medium

  * New upstream release, patch refresh.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 16 Mar 2017 00:04:58 +0100

virtualbox (5.1.16-dfsg-1) unstable; urgency=medium

  [ David Baumann ]
  * Fix desktop file (LP: #1507324)

  [ Gianfranco Costamagna ]
  * New upstream release, patch refresh.
  * Drop upstream patch for linux 4.10

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 06 Mar 2017 15:09:23 +0100

virtualbox (5.1.14-dfsg-3) unstable; urgency=medium

  [ Andreas Pokorny ]
  * Add support for Unity8 (LP: #1669807)

  [ Gianfranco Costamagna ]
  * Update virtualbox desktop file.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 03 Mar 2017 19:28:43 +0100

virtualbox (5.1.14-dfsg-2) unstable; urgency=medium

  [ Seth Forshee ]
  * Cherry pick upstream commit 65409 to fix build with Linux 4.10.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 16 Feb 2017 20:10:54 +0100

virtualbox (5.1.14-dfsg-1) unstable; urgency=medium

  * New upstream release.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 17 Jan 2017 16:00:00 +0100



=== debian/control ===
Source: virtualbox-hwe
Section: contrib/misc
Priority: optional
Maintainer: Debian Virtualbox Team <pkg-virtualbox-devel@lists.alioth.debian.org>
Uploaders: Ritesh Raj Sarraf <rrs@debian.org>,
           Gianfranco Costamagna <locutusofborg@debian.org>
Build-Depends: bzip2,
               debhelper (>= 9),
               default-jdk,
               dh-python,
               dh-systemd (>=1.5),
               dkms (>= 2.1.1.1),
               docbook-xml,
               docbook-xsl,
               dpkg-dev (>= 1.15.6~),
               g++-multilib,
               genisoimage,
               gsoap (>= 2.8.16),
               iasl,
               imagemagick,
               kbuild (>= 1:0.1.9998svn2814~),
               libasound2-dev,
               libcap-dev,
               libcurl4-gnutls-dev,
               libdevmapper-dev,
               libdrm-dev,
               libegl1-mesa-dev,
               libgl1-mesa-dev,
               libglu1-mesa-dev,
               libidl-dev,
               libpam0g-dev,
               libpixman-1-dev,
               libpng-dev,
               libpulse-dev,
               libqt5x11extras5-dev,
               libqt5opengl5-dev,
               qttools5-dev-tools,
               libsdl1.2-dev,
               libssl-dev,
               libvncserver-dev,
               libvpx-dev,
               libx11-dev,
               libxcomposite-dev,
               libxcursor-dev,
               libxdamage-dev,
               libxext-dev,
               libxi-dev,
               libxinerama-dev,
               libxml2-dev,
               libxml2-utils,
               libxmu-dev,
               libxrandr-dev,
               libxrender-dev,
               libxslt1-dev,
               libxt-dev,
               lsb-release,
               lynx-cur,
               makeself,
               module-assistant,
               python3-dev,
               texlive-fonts-extra,
               texlive-fonts-recommended,
               texlive-latex-extra,
               texlive-latex-recommended,
               uuid-dev,
               x11proto-gl-dev,
               x11proto-xf86dri-dev,
               xserver-xorg-dev-hwe-16.04,
               xsltproc,
               yasm (>= 0.7.0),
               zlib1g-dev
X-Python-Version: >= 2.5
Standards-Version: 4.1.1
Homepage: http://www.virtualbox.org/
Vcs-Git: https://anonscm.debian.org/git/pkg-virtualbox/virtualbox.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-virtualbox/virtualbox.git

#Package: virtualbox-qt
#Architecture: amd64 i386
#Depends: virtualbox (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
#Breaks: virtualbox (<< 4.1.6-dfsg-2~)
#Replaces: virtualbox (<< 4.1.6-dfsg-2~)
#Description: x86 virtualization solution - Qt based user interface
# VirtualBox is a free x86 virtualization solution allowing a wide range
# of x86 operating systems such as Windows, DOS, BSD or Linux to run on a
# Linux system.
# .
# This package provides the Qt based graphical user interface for VirtualBox.
#
#Package: virtualbox
#Architecture: amd64 i386
#Depends: adduser,
#         iproute2,
#         procps,
#         virtualbox-dkms (>= ${source:Version}) | virtualbox-source (>= ${source:Version}) | virtualbox-modules,
#         ${misc:Depends},
#         ${python3:Depends},
#         ${shlibs:Depends}
#Recommends: virtualbox-qt (= ${binary:Version}), ${shlibs:Recommends}
#Suggests: vde2, virtualbox-guest-additions-iso
#Conflicts: virtualbox-2.0,
#           virtualbox-2.1,
#           virtualbox-2.2,
#           virtualbox-3.0,
#           virtualbox-3.1,
#           virtualbox-3.2,
#           virtualbox-4.0,
#           virtualbox-4.1,
#           virtualbox-4.2,
#           virtualbox-4.3,
#           virtualbox-5.0,
#           virtualbox-5.1,
#Description: x86 virtualization solution - base binaries
# VirtualBox is a free x86 virtualization solution allowing a wide range
# of x86 operating systems such as Windows, DOS, BSD or Linux to run on a
# Linux system.
# .
# This package provides the binaries for VirtualBox. Either the virtualbox-dkms
# or the virtualbox-source package is also required in order to compile the
# kernel modules needed for virtualbox. A graphical user interface for
# VirtualBox is provided by the package virtualbox-qt.
#
#Package: virtualbox-dkms
#Section: contrib/kernel
#Architecture: all
#Depends: ${misc:Depends}
#Recommends: virtualbox (>= ${source:Version})
#Provides: virtualbox-modules
#Description: x86 virtualization solution - kernel module sources for dkms
# VirtualBox is a free x86 virtualization solution allowing a wide range
# of x86 operating systems such as Windows, DOS, BSD or Linux to run on a
# Linux system.
# .
# This package provides the source code for the virtualbox kernel module to be
# build with dkms. Kernel sources or headers are required to compile this
# module.
#
#Package: virtualbox-source
#Section: contrib/kernel
#Architecture: all
#Depends: build-essential,
#         bzip2,
#         debhelper (>= 9),
#         kbuild,
#         module-assistant,
#         ${misc:Depends}
#Recommends: virtualbox (>= ${source:Version})
#Description: x86 virtualization solution - kernel module source
# VirtualBox is a free x86 virtualization solution allowing a wide range
# of x86 operating systems such as Windows, DOS, BSD or Linux to run on a
# Linux system.
# .
# This package provides the source code for the virtualbox kernel module.
# The virtualbox package is also required in order to make use of these
# modules. Kernel sources or headers are required to compile this module.
# .
# The source is placed under /usr/src, and after decompression it can
# be built to produce a virtualbox-modules-_KVERS_ providing
# "virtualbox-modules" package.

Package: virtualbox-guest-dkms-hwe
Section: contrib/kernel
Architecture: all
Depends: virtualbox-guest-utils-hwe (>= ${source:Version}), ${misc:Depends}
XB-Modaliases: ${modaliases}
Replaces: virtualbox-guest-dkms
Provides: virtualbox-guest-modules,
          virtualbox-guest-dkms
Conflicts: virtualbox-guest-dkms
Description: x86 virtualization solution - guest addition module source for dkms
 VirtualBox is a free x86 virtualization solution allowing a wide range
 of x86 operating systems such as Windows, DOS, BSD or Linux to run on a
 Linux system.
 .
 This package provides the source code for the virtualbox-hwe guest addition kernel
 modules to be build with dkms. Kernel sources or headers are required to
 compile these modules.

Package: virtualbox-guest-source-hwe
Section: contrib/kernel
Architecture: all
Depends: build-essential,
         bzip2,
         debhelper (>= 9),
         kbuild,
         module-assistant,
         ${misc:Depends}
Replaces: virtualbox-guest-source
Provides: virtualbox-guest-source
Conflicts: virtualbox-guest-source
Description: x86 virtualization solution - guest addition module source
 VirtualBox is a free x86 virtualization solution allowing a wide range
 of x86 operating systems such as Windows, DOS, BSD or Linux to run on a
 Linux system.
 .
 This package provides the source code for the virtualbox guest addition kernel
 modules. The virtualbox-guest-utils package is also required in order to
 make use of these modules. Kernel sources or headers are required to compile
 these modules.
 .
 The source is placed under /usr/src, and after decompression it can
 be built to produce a virtualbox-guest-modules-_KVERS_ providing
 "virtualbox-guest-modules" package.

Package: virtualbox-guest-x11-hwe
Section: contrib/x11
Architecture: amd64 i386
Depends: libnotify-bin,
         x11-xserver-utils,
         virtualbox-guest-utils-hwe (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
         ${xserver:Depends}
Replaces: virtualbox-guest-x11
Provides: xorg-driver-video,
          virtualbox-guest-x11
Conflicts: virtualbox-guest-x11
XB-Modaliases: ${modaliases}
Description: x86 virtualization solution - X11 guest utilities
 VirtualBox is a free x86 virtualization solution allowing a wide range
 of x86 operating systems such as Windows, DOS, BSD or Linux to run on a
 Linux system.
 .
 This package provides the X11 guest utilities for VirtualBox. These utilities
 are meant to be run inside the virtual machine.
 They provide closer integration and improve the interactive performance.

Package: virtualbox-guest-utils-hwe
Architecture: amd64 i386
Depends: adduser, pciutils, ${misc:Depends}, ${shlibs:Depends}
Recommends: virtualbox-guest-dkms-hwe (= ${source:Version}) | virtualbox-guest-source-hwe (= ${source:Version}) | virtualbox-guest-modules-hwe,
            virtualbox-guest-x11-hwe (= ${binary:Version})
Replaces: virtualbox-guest-utils
Provides: virtualbox-guest-utils
Conflicts: virtualbox-guest-utils
Description: x86 virtualization solution - non-X11 guest utilities
 VirtualBox is a free x86 virtualization solution allowing a wide range
 of x86 operating systems such as Windows, DOS, BSD or Linux to run on a
 Linux system.
 .
 This package provides the non-X11 guest utilities for VirtualBox. These
 utilities are meant to be run inside the virtual machine.
 They provide closer integration and allow to share data through shared folders
 between the host system and the virtual machine.
 .
 Either the virtualbox-guest-dkms or the virtualbox-guest-source package is
 also required in order to compile the kernel modules needed for
 virtualbox-guest-utils.

=== debian/rules ===
#!/usr/bin/make -f

# Name of the source packages
psource:=virtualbox-source
gsource:=virtualbox-guest-source-hwe
pdkms:=virtualbox-dkms
gdkms:=virtualbox-guest-dkms-hwe

# The short upstream name
sname:=virtualbox
sxname:=virtualbox-qt
gname:=virtualbox-guest
uname:=virtualbox-guest-utils-hwe
uxname:=virtualbox-guest-x11-hwe

INSTALL_PATH:=/usr/lib/virtualbox
MAKE:=kmk

upstreamversion := $(shell dpkg-parsechangelog | sed -n 's/^Version: *\([^-]\+\)-.\+/\1/p')

DIST_NAME := $(shell lsb_release -si)
DIST_RELEASE := $(DIST_NAME)/$(shell lsb_release -sc)

SERVER_DEPENDS = $(shell cat /usr/share/xserver-xorg/videodrvdep 2>/dev/null)

export DEB_BUILD_HARDENING=1
export DEB_BUILD_HARDENING_PIE=0
export DEB_BUILD_HARDENING_FORMAT=0
export DEB_BUILD_HARDENING_BINDNOW=0

export DEB_BUILD_MAINT_OPTIONS = hardening=+all,-pie,-format,-bindnow

%:
	dh $@ --with python3,dkms,systemd

override_dh_auto_configure:
	@echo Building for $(DIST_RELEASE)

ifeq ($(strip $(SERVER_DEPENDS)),)
	@echo 'error: SERVER_DEPENDS is empty'
	@exit 1
endif

	mkdir -p out
	./configure \
	    --ose \
	    --odir=$(abspath out) \
	    --with-linux="/usr" \
	    --disable-kmods \
	    --enable-webservice \
	    --enable-vde \
	    --enable-vnc

override_dh_python3:
	dh_python3 --no-ext-rename

override_dh_auto_build:
	# Building package
	. out/env.sh && $(MAKE) \
	    AUTOCFG=$(abspath out/AutoConfig.kmk) \
	    LOCALCFG=$(abspath debian/LocalConfig.kmk) \
	    PATH_OUT=$(abspath out) \
	    TOOL_YASM_AS=yasm \
	    VBOX_USE_SYSTEM_XORG_HEADERS=1 \
	    VBOX_NO_LEGACY_XORG_X11=1 \
	    VBOX_BUILD_PUBLISHER=_$(DIST_NAME) \
	    VBOX_WITH_REGISTRATION_REQUEST= \
	    VBOX_WITH_UPDATE_REQUEST= \
	    KBUILD_VERBOSE=2 \
	    VBOX_WITH_EXTPACK_VBOXDTRACE=

	xsltproc --nonet --stringparam section.autolabel 1 \
	    -o debian/README.Debian.html \
	    /usr/share/xml/docbook/stylesheet/nwalsh/html/docbook.xsl \
	    debian/virtualbox.files/README.Debian.xml

	chmod 755 debian/lynx-dump-postprocess
	export LC_ALL=C; lynx -force_html -dump debian/README.Debian.html | \
	    ./debian/lynx-dump-postprocess > debian/virtualbox.README.Debian.tmp
	mv debian/virtualbox.README.Debian.tmp debian/virtualbox.README.Debian

override_dh_auto_install:
	dh_auto_install

	export VBOX_INSTALL_PATH=$(INSTALL_PATH) && \
	    cd out/bin/sdk/installer && \
	    python3 ./vboxapisetup.py install --root $(CURDIR)/debian/$(sname)

	sed -e 's/CVERSION/$(upstreamversion)/g' < debian/$(gdkms).links.in > debian/$(gdkms).links
	sed -e 's/CVERSION/$(upstreamversion)/g' < debian/$(pdkms).links.in > debian/$(pdkms).links

	# Build install files for the dkms'ified sources
	sed -e 's/CVERSION/$(upstreamversion)/g' < debian/$(pdkms).install.in > debian/$(pdkms).install
	sed -e 's/CVERSION/$(upstreamversion)/g' < debian/$(gdkms).install.in > debian/$(gdkms).install

	echo "xserver:Depends=$(SERVER_DEPENDS)" >> debian/$(uxname).substvars

ifeq ($(DIST_NAME),Ubuntu)
	echo "modaliases=vboxguest(pci:v000080EEd0000CAFEsv00000000sd00000000bc*sc*i*)" >> debian/$(gdkms).substvars
	echo "modaliases=vboxx11(pci:v000080EEd0000BEEFsv00000000sd00000000bc*sc*i*)" >> debian/$(uxname).substvars
endif

override_dh_install:
	dh_install -p$(sname) -X out/bin/VBoxDbg.so
	dh_install --remaining-packages
#ifneq (,$(filter $(uxname), $(shell dh_listpackages)))
#	install -m 644 -p -D out/bin/additions/vboxvideo_drv_system.so \
#	    debian/$(uxname)/usr/lib/xorg/modules/drivers/vboxvideo_drv.so
#endif
# check if arch-any packages are being built
ifneq (,$(filter $(sxname), $(shell dh_listpackages)))
	convert debian/$(sxname)/usr/share/icons/hicolor/32x32/apps/virtualbox.png \
	    debian/$(sxname)/usr/share/pixmaps/virtualbox.xpm
endif

ifeq ($(DIST_NAME),Ubuntu)
	install -m 644 -p -D debian/apport-hook.py \
	    debian/$(sname)/usr/share/apport/package-hooks/source_$(sname).py
	install -m 644 -p -D debian/apport-hook.py \
	    debian/$(gdkms)/usr/share/apport/package-hooks/$(gdkms).py
endif

override_dh_link:
	dh_link
	dh_link -p$(uxname) --ignore debian/$(uxname).links \
	    /usr/lib/VBoxOGL.so $(shell pkg-config --variable dridriverdir dri)/vboxvideo_dri.so

override_dh_fixperms:
	dh_fixperms

# check if arch-any packages are being built
ifneq (,$(filter $(sname), $(shell dh_listpackages)))
	chmod +s debian/$(sname)$(INSTALL_PATH)/VBoxSDL;
	chmod +s debian/$(sname)$(INSTALL_PATH)/VBoxHeadless;
	chmod +s debian/$(sname)$(INSTALL_PATH)/VBoxNetDHCP;
	chmod +s debian/$(sname)$(INSTALL_PATH)/VBoxNetAdpCtl;
	chmod 644 debian/$(sname)$(INSTALL_PATH)/*.rc;
	chmod 644 debian/$(sname)$(INSTALL_PATH)/*.r0;

	chmod 644 debian/$(sname)$(INSTALL_PATH)/sdk/bindings/xpcom/python/xpcom/*.py;
	chmod 644 debian/$(sname)$(INSTALL_PATH)/sdk/bindings/xpcom/python/xpcom/server/*.py;
	chmod 644 debian/$(sname)$(INSTALL_PATH)/sdk/bindings/xpcom/python/xpcom/client/*.py;
	chmod 644 debian/$(sname)$(INSTALL_PATH)/sdk/bindings/xpcom/java/vboxjxpcom.jar;

	chmod 755 debian/$(sname)/usr/share/virtualbox/VBox.sh;
endif

ifneq (,$(filter $(sxname), $(shell dh_listpackages)))
	chmod +s debian/$(sxname)$(INSTALL_PATH)/VirtualBox;
endif

ifneq (,$(filter $(uxname), $(shell dh_listpackages)))
	chmod 755 debian/$(uxname)/usr/share/virtualbox/x11config.pl;
endif

# check if arch-all packages are being built
ifneq (,$(filter $(psource), $(shell dh_listpackages)))
	# These files have incorrect permissions, fixing it.
	chmod 755 debian/$(psource)/usr/src/modules/$(sname)/debian/rules

	# this needs all prior work to be finished
	cd debian/$(psource)/usr/src && \
	    tar -cjf $(sname).tar.bz2 modules && \
	    rm -rf modules

	chmod 644 debian/$(psource)/usr/src/$(sname).tar.bz2
endif

# check if arch-all packages are being built
ifneq (,$(filter $(gsource), $(shell dh_listpackages)))
	# These files have incorrect permissions, fixing it.
	chmod 755 debian/$(gsource)/usr/src/modules/$(gname)/debian/rules

	# this needs all prior work to be finished
	cd debian/$(gsource)/usr/src && \
	    tar -cjf $(gname).tar.bz2 modules && \
	    rm -rf modules

	chmod 644 debian/$(gsource)/usr/src/$(gname).tar.bz2
endif

override_dh_installinit:
	dh_installinit -p$(uxname) --no-start --update-rcd-params="start 45 S ."
	dh_installinit --remaining-packages --no-start

override_dh_systemd_enable:
	dh_systemd_enable -p$(sname) --name vboxweb --no-enable debian/vboxweb.service
	dh_systemd_enable -p$(uname) debian/virtualbox-guest-utils-hwe.service

override_dh_dkms:
	dh_dkms -V $(upstreamversion)

override_dh_strip:
ifneq (,$(filter $(sname), $(shell dh_listpackages)))
	dh_strip --dbgsym-migration='$(sname)-dbg' || dh_strip

	# strip files not handled by dh_strip
ifeq (,$(filter nostrip,$(DEB_BUILD_OPTIONS)))
	set -e && for file in debian/$(sname)/usr/lib/virtualbox/*.rc debian/$(sname)/usr/lib/virtualbox/*.r0; do \
	    strip --strip-debug --remove-section=.comment --remove-section=.note $${file}; \
	done
endif
	# I don't see a reason to have these. If any user complains, we can try ship it.
	rm -f debian/$(sname)/usr/lib/virtualbox/VMMRC.debug
	rm -f debian/$(sname)/usr/lib/virtualbox/VMMR0.debug
endif

override_dh_shlibdeps:
	dh_shlibdeps -p$(sname) -X debian/$(sname)$(INSTALL_PATH)/VBoxTestOGL -- \
	    -dRecommends debian/$(sname)$(INSTALL_PATH)/VBoxTestOGL -dDepends
	dh_shlibdeps --remaining-packages

override_dh_compress:
	dh_compress -X.pdf

override_dh_auto_clean:
	dh_auto_clean

	# Cleaning package
	rm -rf out
	rm -f build-stamp
	rm -f debian/virtualbox.README.Debian debian/README.Debian.html
	rm -f debian/$(pdkms).install
	rm -f debian/$(gdkms).install
	rm -f debian/$(pdkms).links
	rm -f debian/$(gdkms).links

	find . -name "*.pyc" -exec rm -f {} \;

=== debian/watch ===
version=4

opts=downloadurlmangle=s/^/http:/,dversionmangle=s/-dfsg\d*$//,uversionmangle=s/-.*// \
 http://download.virtualbox.org/virtualbox/([\d\.\-]+)/VirtualBox-([\d\.\-]+).tar.bz2 \
 debian /bin/sh debian/get-orig-source.sh
